#!/usr/bin/env python

import os

import pygtk
pygtk.require("2.0")
import gobject
import gtk

import findrox; findrox.version(2, 0, 3)

import rox
import rox.session

PADDING = 20
WM_SETTING = "ROX/WindowManager"

def _(s):
	return s

class WMDialog(gtk.Dialog):
	def __init__(self):
		gtk.Dialog.__init__(self, _("ROX-Session"),
				buttons = (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
						gtk.STOCK_OK, gtk.RESPONSE_OK))
		frame = gtk.Frame(_("<b>Window Manager</b>"))
		frame.get_label_widget().set_use_markup(True)
		frame.set_shadow_type(gtk.SHADOW_NONE)
		label = gtk.Label(_("Enter a window manager command here"))
		vbox = gtk.VBox(True)
		self.vbox.pack_start(frame)
		frame.add(vbox)
		vbox.pack_start(label, PADDING)
		self.wm_command = gtk.Entry()
		vbox.pack_start(self.wm_command, PADDING)
		frame.show_all()
		self.set_default_response(gtk.RESPONSE_OK)
		self.wm_command.set_activates_default(True)
	
	def get_wm_command(self):
		return self.wm_command.get_text()

	def set_wm_command(self, text):
		self.wm_command.set_text(text)


settings = rox.session.get_settings()

def set_wm_and_quit(setting, command):
	settings.SetString(setting, command)
	gtk.main_quit()

dialog = WMDialog()
dialog.set_wm_command(settings.GetSetting(WM_SETTING)[1])
if dialog.run() == gtk.RESPONSE_OK:
	# Make sure dialog is closed before sending message to ROX-Session
	# due to <http://bugzilla.gnome.org/show_bug.cgi?id=513281>
	gobject.idle_add(set_wm_and_quit, WM_SETTING, dialog.get_wm_command())
	dialog.destroy()
	gtk.main()

